from bs4 import BeautifulSoup
import os
import datetime, calendar
import shutil

def startFunct():
	sometime = datetime.datetime.now()
	timestr = sometime.strftime("%d %b %Y %H:%M:%S")
	final_soup = BeautifulSoup(open("final.xml"))
	id = final_soup.test['id']
	src = final_soup.test['source']
	#report = []
	#report = open("tools/selenium/selenium_results.txt",'r').readlines()
	#start_date = ""
	# for line in report:
		# line = line.strip()
		# parts = []
		# parts = line.split('=')
		# if parts[0] == 'test':
			# start_date = parts[1]
	test_soup = BeautifulSoup(open(src + "\\testlist.xml"))
	test_soup.find("case",{'id':id})['start_date'] = timestr
	f = open(src + "\\testlist.xml",'w')
	f.write(str(test_soup))
	f.close()

def mainFunct():
	sometime = datetime.datetime.now()
	timestr = sometime.strftime("%d %b %Y %H:%M:%S")
	final_soup = BeautifulSoup(open("final.xml"))
	id = final_soup.test['id']
	src = final_soup.test['source']
	test_soup = BeautifulSoup(open(src + "\\testlist.xml"))
	test_soup.find("case",{'id':id})['end_date'] = timestr
	f = open(src + "\\testlist.xml",'w')
	f.write(str(test_soup))
	f.close()
	makeReport()
	
def makeReport():
	opening_text = file("report_template.html",'r').read()
	final_soup = BeautifulSoup(open("final.xml"))
	id = final_soup.test['id']
	src = final_soup.test['source']
	report = []
	status = []
	name = []
	command = []
	endTime = []
	report = open("tools/selenium/selenium_results.txt",'r').readlines()
	cnt = 0
	run_status = "PASS"
	test_name = final_soup.findAll('test')[0]['name']
	startDate = 0
	endDate = 0
	for line in report:
		line = line.strip()
		parts = []
		parts = line.split('=')
		if parts[0] == 'step':
			lineStatus = parts[1].split(',')[0]
			lineTime = parts[1].split(',')[1]
			name.append(final_soup.test.findAll('step')[cnt]['name'])
			command.append(final_soup.test.findAll('step')[cnt].execute.text)
			status.append(lineStatus)
			if lineStatus == "FAIL":
				run_status = "FAIL"
			endTime.append(lineTime)
			cnt = cnt + 1
		if parts[0] == 'start':
			startDate = parts[1]
		if parts[0] == 'end':
			endDate = parts[1]
	report_text = ""
	report_text += "<div id='title'>" + test_name + "</div></br>"
	if run_status == "FAIL":
		report_text += "<div id='fail_status'>" + run_status + "</div></br>"
	else:
		report_text += "<div id='pass_status'>" + run_status + "</div></br>"
	report_text += "<b>Start: </b>" + startDate + "</br>"
	report_text += "<b>End: </b>" + endDate + "</br></br>"
	report_text += "<tbody>"
	for i in range(0,cnt):
		status_class = "pass"
		if status[i] == "FAIL":
			status_class = "fail"
		report_text += "<tr class=\"" + status_class  + "\">\n"
		report_text += "<td class=\"display: inline;\">" + str(i+1) + "</td>\n"
		report_text += "<td class=\"display: inline;\">" + status[i] + "</td>\n"
		report_text += "<td class=\"display: inline;\">" + name[i] + "</td>\n"
		report_text += "<td class=\"word-wrap: break-word\">" + command[i] + "</td>\n"
		report_text += "<td class=\"display: inline;\">" + endTime[i] + "</td>\n"
		report_text += "<td class=\"display: inline;\"><a href=\"" + str(i+1) + ".png\">Screenshot</a></td>\n"
		report_text += "</tr>\n"
	report_text += "</tbody>"
	opening_text = opening_text.replace("//INSERT RESULTS",report_text)
	nowDate = datetime.datetime.now()
	nowStr = calendar.timegm(nowDate.utctimetuple())
	if not os.path.exists(src + "\\tests\\" + id + "\\reports\\" + str(nowStr)):
		os.makedirs(src + "\\tests\\" + id + "\\reports\\" + str(nowStr))
	file(src + "\\tests\\" + id + "\\reports\\" + str(nowStr) + "\\report.html",'w').write(opening_text)
	test_soup = BeautifulSoup(open(src + "\\testlist.xml"))
	test_soup.find("case",{'id':id})['status'] = run_status
	f = open(src + "\\testlist.xml",'w')
	startDate = test_soup.find("case",{'id':id})['start_date']
	result_soup = BeautifulSoup(open(src + "\\tests\\" + id + "\\reports.xml"))
	result_soup.reports.append(result_soup.new_tag("result",status=run_status,start_date=startDate))
	result_soup.reports.findAll("result")[-1].string = str(nowStr)
	f_results = open(src + "\\tests\\" + id + "\\reports.xml",'w')
	f_results.write(str(result_soup.prettify()))
	f_results.close()
	f.write(str(test_soup))
	f.close()
	#Copy files from temp to test dir
	screenFnames = []
	screenFnames = os.listdir("tools/selenium/temp")
	for img in screenFnames:
		shutil.copy("tools/selenium/temp/" + img,src + "\\tests\\" + id + "\\reports\\" + str(nowStr))
		#TODO: Do removal on Java's side
		os.remove("tools/selenium/temp/" + img)
	
	